VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form frmWmiDemo 
   Caption         =   "Form1"
   ClientHeight    =   4140
   ClientLeft      =   684
   ClientTop       =   3312
   ClientWidth     =   8076
   LinkTopic       =   "Form1"
   ScaleHeight     =   4140
   ScaleWidth      =   8076
   Begin VB.CommandButton cmdGetProcesses 
      Caption         =   "Get &Processes"
      Height          =   456
      Left            =   2700
      TabIndex        =   7
      Top             =   3564
      Width           =   1188
   End
   Begin VB.TextBox txtMinSize 
      Alignment       =   2  'Center
      Height          =   285
      Left            =   5652
      TabIndex        =   5
      Text            =   "."
      Top             =   72
      Width           =   888
   End
   Begin VB.CommandButton cmdCheckDiskEnum 
      Caption         =   "Check Disks (&Enum)"
      Height          =   456
      Left            =   1404
      TabIndex        =   4
      Top             =   3564
      Width           =   1188
   End
   Begin VB.CommandButton cmdCheckDiskQuery 
      Caption         =   "Check Disks (&Query)"
      Height          =   456
      Left            =   72
      TabIndex        =   3
      Top             =   3564
      Width           =   1188
   End
   Begin VB.CommandButton cmdExit 
      Cancel          =   -1  'True
      Caption         =   "Exit"
      Height          =   456
      Left            =   7344
      TabIndex        =   2
      Top             =   3564
      Width           =   648
   End
   Begin MSComctlLib.ListView ListView 
      Height          =   2940
      Left            =   72
      TabIndex        =   8
      Top             =   468
      Width           =   7944
      _ExtentX        =   14012
      _ExtentY        =   5186
      View            =   3
      LabelEdit       =   1
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      AllowReorder    =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   0
   End
   Begin VB.ListBox List1 
      Height          =   2928
      ItemData        =   "WMI_Disk.frx":0000
      Left            =   72
      List            =   "WMI_Disk.frx":0007
      TabIndex        =   0
      Top             =   468
      Width           =   7944
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "Min Disk Size:"
      Height          =   192
      Left            =   4608
      TabIndex        =   6
      Top             =   108
      Width           =   996
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Disk Drives with > 500 Meg Free Space:"
      Height          =   192
      Left            =   108
      TabIndex        =   1
      Top             =   144
      Width           =   2820
   End
End
Attribute VB_Name = "frmWmiDemo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_objNameSpace                 As SWbemServices

Private WithEvents m_evtServicesSink   As SWbemSink
Attribute m_evtServicesSink.VB_VarHelpID = -1
Private m_objServices                  As SWbemServices

Private m_dblMinSizeBytes              As Double
Private m_dblMinSizeMegs               As Double

Private Const constLocalDrives         As Long = 3&

Private Const NORMAL_PRIORITY_CLASS    As Long = &H20
Private Const IDLE_PRIORITY_CLASS      As Long = &H40
Private Const HIGH_PRIORITY_CLASS      As Long = &H80
Private Const REALTIME_PRIORITY_CLASS  As Long = &H100

Private Sub cmdExit_Click()
   
   If Not (m_objNameSpace Is Nothing) Then
      Set m_objNameSpace = Nothing
   End If
   
   If Not (m_evtServicesSink Is Nothing) Then
      Set m_evtServicesSink = Nothing
   End If
   
   Unload Me

End Sub

Private Sub Form_Load()
On Error GoTo ErrorHandler
   
   Me.Label1.Caption = "Select a button below:"
   Me.List1.Visible = True
   Me.ListView.Visible = False
   
   ' ------------------------------------------
   ' Set minimum size to 500 Megs
   ' ------------------------------------------
   Me.txtMinSize.Text = "500"
   m_dblMinSizeMegs = CDbl(Trim$(Me.txtMinSize.Text))
   m_dblMinSizeBytes = ((1024# * 1024#) * m_dblMinSizeMegs)
   
   ' ------------------------------------------
   ' Login to the root\cimv2 m_objNameSpace
   '     where all the WIN32 information is stored.
   ' ------------------------------------------
   Set m_objNameSpace = GetObject("winmgmts:")
   
   ' ------------------------------------------
   ' Set the impersonation level appropriately
   ' ------------------------------------------
   m_objNameSpace.Security_.ImpersonationLevel = wbemImpersonationLevelImpersonate
   
Exit Sub
ErrorHandler:
   MsgBox "An error has ocurred loading the form: " & Err.Description
End Sub

Private Sub cmdGetProcesses_Click()
   
   Me.Label1.Caption = "Win32 Processes currently running:"
   
   Me.MousePointer = vbHourglass
   Screen.MousePointer = vbHourglass
   Me.Enabled = False
     
   Me.List1.Visible = False
   Me.ListView.Visible = True
   
   Me.ListView.ColumnHeaders.Clear
   Me.ListView.ListItems.Clear
   SetupProcessesListview
   
   Set m_evtServicesSink = New SWbemSink
   Set m_objServices = GetObject("winmgmts:{impersonationLevel=impersonate,(Debug)}")

   ' Perform the asynchronous enumeration of processes
   m_objServices.InstancesOfAsync objWbemSink:=m_evtServicesSink, _
                                  strClass:="Win32_process"
End Sub

Private Sub cmdCheckDiskEnum_Click()
On Error GoTo ErrorHandler
   Dim Disk                   As SWbemObject
   Dim DiskSet                As SWbemObjectSet
   Dim p_vntValue             As Variant
   Dim p_strVolName           As String
   Dim p_strDiskID            As String
   Dim p_dblFreeSpace         As Double
   Dim p_strQuery             As String
   
   Me.List1.Visible = True
   Me.ListView.Visible = False
   
   m_dblMinSizeMegs = CDbl(Trim$(Me.txtMinSize.Text))
   m_dblMinSizeBytes = ((1024# * 1024#) * m_dblMinSizeMegs)
   
   Me.Label1.Caption = "Disk Drives with > " & _
                       CStr(m_dblMinSizeMegs) & _
                       " Meg Free Disk Space:"
   
   Me.MousePointer = vbHourglass
   Screen.MousePointer = vbHourglass
   Me.Enabled = False
   Me.List1.Clear
     
   ' ------------------------------------------
   ' Enumerate the instances of Win32_LogicalDisk
   ' ------------------------------------------
   Set DiskSet = m_objNameSpace.InstancesOf("Win32_LogicalDisk")
   For Each Disk In DiskSet
   
      p_vntValue = Disk.DriveType
      Debug.Print p_vntValue
   
      If Not IsNull(p_vntValue) Then
         If CLng(p_vntValue) = constLocalDrives Then
   
            p_dblFreeSpace = CDbl(Disk.FreeSpace)
   
            If Not IsNull(p_vntValue) Then
               If p_dblFreeSpace < m_dblMinSizeBytes Then
   
                  p_vntValue = Disk.DeviceID
                  If Not IsNull(p_vntValue) Then
                     p_strDiskID = CStr(p_vntValue)
                  Else
                     p_strDiskID = "???:"
                  End If

                  p_vntValue = Disk.VolumeName
                  If Not IsNull(p_vntValue) Then
                     p_strVolName = CStr(p_vntValue)
                  Else
                     p_strVolName = "Unknown"
                  End If
   
                  If p_dblFreeSpace > 0 Then
                     p_dblFreeSpace = p_dblFreeSpace / (1024# * 1024#)
                  End If
   
                  Me.List1.AddItem "Vol " & p_strDiskID & _
                                    " [" & p_strVolName & "]" & _
                                    " has only " & _
                                    Format$(p_dblFreeSpace, "###,###,###,##0.0#") & _
                                    " MEG free!"
                  'Me.List1.AddItem "Vol " & p_strDiskID & " [" & p_strVolName & "]" & _
                                   " has only " & _
                                   Format$(p_dblFreeSpace, "###,###,###,##0.0#") & _
                                   " MEG free!"
               End If
            End If
         End If
   
      End If
   
   Next
       
   Me.MousePointer = vbNormal
   Screen.MousePointer = vbNormal
   Me.Enabled = True
   
Exit Sub
ErrorHandler:
   MsgBox "An error has ocurred: " & Err.Description
   Me.MousePointer = vbNormal
   Screen.MousePointer = vbNormal

End Sub

Private Sub cmdCheckDiskQuery_Click()
On Error GoTo ErrorHandler
   Dim Disk                   As SWbemObject
   Dim DiskSet                As SWbemObjectSet
   Dim p_vntValue             As Variant
   Dim p_strVolName           As String
   Dim p_strDiskID            As String
   Dim p_dblFreeSpace         As Double
   Dim p_strQuery             As String
   
   Me.List1.Visible = True
   Me.ListView.Visible = False
   
   m_dblMinSizeMegs = CDbl(Trim$(Me.txtMinSize.Text))
   m_dblMinSizeBytes = ((1024# * 1024#) * m_dblMinSizeMegs)
   
   Me.Label1.Caption = "Disk Drives with > " & _
                       CStr(m_dblMinSizeMegs) & _
                       " Meg Free Disk Space:"
   
   Me.MousePointer = vbHourglass
   Screen.MousePointer = vbHourglass
   Me.Enabled = False
   Me.List1.Clear
     
   ' ------------------------------------------
   ' Use a query to get just the objects we want
   ' ------------------------------------------
   p_strQuery = "Select FreeSpace, Size, Name, VolumeName " & _
                "FROM Win32_LogicalDisk " & _
                "WHERE " & _
                "DriveType=" & constLocalDrives
   Set DiskSet = m_objNameSpace.ExecQuery(strQuery:=p_strQuery)
   For Each Disk In DiskSet
            
      p_vntValue = CDbl(Disk.FreeSpace)

      If Not IsNull(p_vntValue) Then
         p_dblFreeSpace = CDbl(Disk.FreeSpace)
         
         If p_dblFreeSpace < m_dblMinSizeBytes Then
   
            p_vntValue = Disk.DeviceID
            If Not IsNull(p_vntValue) Then
               p_strDiskID = CStr(p_vntValue)
            Else
               p_strDiskID = "???:"
            End If
            
            p_vntValue = Disk.VolumeName
            If Not IsNull(p_vntValue) Then
               p_strVolName = CStr(p_vntValue)
            Else
               p_strVolName = "Unknown"
            End If

            If p_dblFreeSpace > 0 Then
               p_dblFreeSpace = p_dblFreeSpace / (1024# * 1024#)
            End If
            
            Me.List1.AddItem "Vol " & p_strDiskID & _
                              " [" & p_strVolName & "]" & _
                              " has only " & _
                              Format$(p_dblFreeSpace, "###,###,###,##0.0#") & _
                              " MEG free!"
         End If
      End If
   Next
     
   Me.MousePointer = vbNormal
   Screen.MousePointer = vbNormal
   Me.Enabled = True
   
Exit Sub
ErrorHandler:
   MsgBox "An error has ocurred: " & Err.Description
   Me.MousePointer = vbNormal
   Screen.MousePointer = vbNormal
End Sub

Private Sub SetupProcessesListview()
   Dim p_objColHeader               As ColumnHeader
   
   Set p_objColHeader = Me.ListView.ColumnHeaders.Add()
   p_objColHeader.Text = "Name"
   p_objColHeader.Width = 2300
   
   Set p_objColHeader = Me.ListView.ColumnHeaders.Add()
   p_objColHeader.Text = "PID"
   p_objColHeader.Width = 450
   
   Set p_objColHeader = Me.ListView.ColumnHeaders.Add()
   p_objColHeader.Text = "Priority"
   p_objColHeader.Width = 700
   
   Set p_objColHeader = Me.ListView.ColumnHeaders.Add()
   p_objColHeader.Text = "Working Set"
   p_objColHeader.Width = 1100
   
   Set p_objColHeader = Me.ListView.ColumnHeaders.Add()
   p_objColHeader.Text = "User Mode"
   p_objColHeader.Width = 1000
   
   Set p_objColHeader = Me.ListView.ColumnHeaders.Add()
   p_objColHeader.Text = "Kernel Mode"
   p_objColHeader.Width = 1100
   
   Set p_objColHeader = Me.ListView.ColumnHeaders.Add()
   p_objColHeader.Text = "Page Faults"
   p_objColHeader.Width = 1100
   
End Sub

Private Function PriorityText(ByVal xi_lngPriority As Long) As String

   Select Case xi_lngPriority
      Case NORMAL_PRIORITY_CLASS
         PriorityText = "Normal"
      Case IDLE_PRIORITY_CLASS
         PriorityText = "Idle"
      Case HIGH_PRIORITY_CLASS
         PriorityText = "High"
      Case REALTIME_PRIORITY_CLASS
         PriorityText = "Real-Time"
      Case Else
         PriorityText = ""
   End Select
      
End Function

Private Sub m_evtServicesSink_OnCompleted(ByVal iHResult As WbemScripting.WbemErrorEnum, _
                                          ByVal objWbemErrorObject As WbemScripting.ISWbemObject, _
                                          ByVal objWbemAsyncContext As WbemScripting.ISWbemNamedValueSet)
    Me.MousePointer = vbNormal
    Screen.MousePointer = vbNormal
    Me.cmdGetProcesses.Enabled = True
    Me.Enabled = True
    
    If (iHResult <> wbemNoErr) Then
        MsgBox "Error: " & Err.Description & " [0x" & Hex(Err.Number) & "]", vbOKOnly
    End If
    
End Sub

' This event handler is called once for every process
'     returned by the enumeration
Private Sub m_evtServicesSink_OnObjectReady(ByVal Process As WbemScripting.ISWbemObject, _
                                            ByVal objWbemAsyncContext As WbemScripting.ISWbemNamedValueSet)
   Dim p_strKey                     As String
   Dim p_objItem                    As ListItem
   Dim p_vntTime                    As Variant
   Dim p_lngPriority                As Long
   
   Set p_objItem = Me.ListView.ListItems.Add(, p_strKey, Process.Name)
   p_objItem.SubItems(1) = Process.Handle
   
   If vbNull <> VarType(Process.Priority) Then
      p_lngPriority = Process.Priority
      
   Else
      p_lngPriority = 0
   End If
   p_objItem.SubItems(2) = PriorityText(xi_lngPriority:=p_lngPriority)
   
   If vbNull <> VarType(Process.WorkingSetSize) Then
      p_objItem.SubItems(3) = CStr(Process.WorkingSetSize / 1024) & " K"
   Else
      p_objItem.SubItems(3) = "0 K"
   End If
    
   p_vntTime = Process.UserModeTime
   If vbNull <> VarType(p_vntTime) Then
      p_vntTime = p_vntTime / (60000#)
      p_objItem.SubItems(4) = Format$(p_vntTime, "#,###,###,###,##0.0000") & " min"
   Else
      p_objItem.SubItems(4) = "0"
   End If
      
   p_vntTime = Process.KernelModeTime
   If vbNull <> VarType(p_vntTime) Then
      p_vntTime = p_vntTime / (60000#)
      p_objItem.SubItems(5) = Format$(p_vntTime, "#,###,###,###,##0.0000") & " min"
   Else
      p_objItem.SubItems(5) = "0"
   End If
      
   If vbNull <> VarType(Process.PageFaults) Then
      p_objItem.SubItems(6) = Process.PageFaults
   Else
      p_objItem.SubItems(6) = "0"
   End If
      
End Sub
